/***************************************************************************
                          dirsdata.h  -  description
                             -------------------
    begin                : ??? ??? 10 2003
    copyright            : (C) 2003 by Spiros Georgaras
    email                : sngeorgaras@otenet.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIRSDATA_H
#define DIRSDATA_H
#include <qdir.h>
#include <qregexp.h>
#include <filesdata.h>

/**
  *@author Spiros Georgaras
  */

class dirsData : public filesData  {
public:
  struct filePart{
    QString pref;
	QString suf;
	int digitNum;
	QString ext;
	int partType;	//0: number only, 1: pref + number, 2: number +suffix, 3: all
	}fPart;

  struct newFile{
    QString oldFileName;
    QString oldName;
    QString oldExtension;
    QString newFileName;
    QString newTmpFileName;
    QString newName;
    QString newTmpName;
    QString Counter;
    QString newExtension;
    QString Suffix;
    QString Prefix;
    int inc;
    int randomNum;
    bool selected;
    bool isDir;
  };
  
	dirsData();
	~dirsData();
  void setPath(QString path,const QString &nameFilter,int filterSpec);
  QString path(void);
  void setFilter(int filterSpec);
  int filter(void);
  newFile * ren;
  int setLink(filesData * b);
  int numOfDigits;
  int getSorted(int i);
  int setSortValue(bool state);
private:
  QString mPath;
  int mFilter;
  QString mNameFilter;
  int * sort;
  bool sortID;
  bool hasBeenSorted;
};

#endif
