/***************************************************************************
                          exif.h  -  description
                             -------------------
    begin                : ??? ??? 9 2004
    copyright            : (C) 2004 by Spiros Georgaras
    email                : sngeorgaras@otenet.gr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EXIF_H
#define EXIF_H
#include <qstring.h>
#include <qfile.h>
#include <qdatastream.h>

//#define offset 12
#define mDate 0x0132
#define cDate 0xFFFF9003
#define subID 0xFFFF8769
/**
  *@author Spiros Georgaras
  */

class EXIF {
public: 
	EXIF(QString fName);
	~EXIF();
  bool isExif;
  QString getExifDate(int mode);
private:
	Q_INT32 getIFDoffset(void);
	Q_INT16 getNumOFIFDEntries(void);
	QString getDate(Q_INT16 EntryID);
  Q_INT32 getSubOffset(void);
  Q_INT16 getNumOfSunEntries(void);
	bool checkExif(void);
	QString fileName;
  QFile ff;
  QDataStream ds;
	int fileType;
	Q_INT32 IFDoffset;
	Q_INT16 numOfEntries;
	Q_INT32 subIFDoffset;
	Q_INT16 numOfSunEntries;
	Q_INT16 offset;
};

#endif
